/*
 * ۼ ¥: 2005. 10. 4.
 *
 */
package test.openlbs.db;

import java.io.ByteArrayInputStream;
import java.io.ObjectInputStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Blob;

import com.openlbs.common.property.Property;
import com.openlbs.common.util.SystemViewManager;
import com.openlbs.datamanager.SP_Query;
import com.openlbs.datamanager.SQLManager;
import com.openlbs.datamanager.SQLMetaFunction;
import com.openlbs.datamanager.SQLQuery;
import com.openlbs.datamanager.SQLQueryString;


/**
 * @author hhjang97
 *
 * DB BLOB JAVA ü ϰ ´. 
 * 
 */
public class DbSpatialObject {
	private SQLManager sqlfunc = new SQLMetaFunction();
	private Property lp = Property.getInstance();
	
	
	public void savePolygon(String req_id, TestObject saveObject) {
		PreparedStatement pstmt = null;
		ResultSet rs;
		String sql = null;
		
		try{
			if(!sqlfunc.mConnection(lp.DB_PROPERTY_NAME)){ 
				System.out.println("DB Connection Error....");
			}
 
			SQLQuery sqlQuery = new SQLQueryString();
			SP_Query sqlObj = (SP_Query)sqlQuery.getQueryObj(lp.POLLING_REPORT_SQL);
			
			// ϴ ׳ϰ  ߰Ѵ.
			sql = "INSERT INTO  tbl_tlpolygon (req_id, spatial_val) values(?, ?) ";
			SystemViewManager.debug("SqlQuery :"+sql);
			
			pstmt = (sqlfunc.getMConnection()).prepareStatement(sql);
			
			
			// Object  ȭ Ѵ.
			java.io.ByteArrayOutputStream bos = new java.io.ByteArrayOutputStream();
			java.io.ObjectOutputStream oos = new java.io.ObjectOutputStream(bos);
			oos.writeObject(saveObject);
			
			byte[] bytes = bos.toByteArray();
			oos.close();
			bos.close();
			
			ByteArrayInputStream regArrayStream = 
							new ByteArrayInputStream(bytes);

			pstmt.setString(1, req_id);
			pstmt.setBinaryStream( 2, regArrayStream, bytes.length);
			
			if (pstmt.executeUpdate() != 1) {
				SystemViewManager.debug(" tbl_tlpolygon INSERT !! ");
			} else {
				SystemViewManager.debug(" tbl_tlpolygon INSERT !! ");
			}

		} catch(Exception e){
			
			e.printStackTrace();
			SystemViewManager.monitor("tbl_tlpolygon  insert error");
			SystemViewManager.monitor("java.io.NotSerializableException ΰ ");
			SystemViewManager.monitor(" Serialize ϴ ü Ҽӵ ü鵵 Serialize ؾ Ѵ. ");
		}finally{
			try{if(pstmt != null) sqlfunc.mPreparedStatementClose(pstmt); } catch (Exception ex){}			
			try{	sqlfunc.mConnectionClose();	}catch(SQLException seq){ seq.printStackTrace(); }
		}

	  
	}
	
	
	
	public TestObject getPolygon(String req_id) {
		PreparedStatement pstmt = null;
		ResultSet rs;
		String sql = null;
		
		TestObject returnObject = null;
		 
		try{
			if(!sqlfunc.mConnection(lp.DB_PROPERTY_NAME)){ 
				System.out.println("DB Connection Error....");
			}
 
			SQLQuery sqlQuery = new SQLQueryString();
			SP_Query sqlObj = (SP_Query)sqlQuery.getQueryObj(lp.POLLING_REPORT_SQL);
			
			// ϴ ׳ϰ  ߰Ѵ.			
			sql = "SELECT spatial_val  FROM tbl_tlpolygon WHERE req_id = ? ";
			SystemViewManager.debug("SqlQuery :"+sql);
			
			pstmt = (sqlfunc.getMConnection()).prepareStatement(sql);
			
			pstmt.setString(1,req_id);
			
			rs = sqlfunc.mSelectPreparedStatement(pstmt);
			
			if (rs.next()) {
				// BLOB б
				Blob blob = rs.getBlob("spatial_val");

				ObjectInputStream regObjectStream =	new ObjectInputStream(blob.getBinaryStream());
				returnObject = (TestObject) regObjectStream.readObject();

			} else {
				System.out.println(" tbl_tlpolygon Select Not Found ! ");
			}

			
		} catch(Exception e){
			SystemViewManager.monitor("tbl_tlpolygon  search error");
			e.printStackTrace();
		}finally{
			try{if(pstmt != null) sqlfunc.mPreparedStatementClose(pstmt); } catch (Exception ex){}			
			try{	sqlfunc.mConnectionClose();	}catch(SQLException seq){ seq.printStackTrace(); }
		}
		
		return returnObject;
	  
	} // 
	
	
	
	public static void main(String[] args) {

	  DbSpatialObject test = new DbSpatialObject();
	  TestObject saveObject = new TestObject();
	 
	  String req_id = "200509091111111123001";
	  
	  test.savePolygon(req_id, saveObject);	// insert
	 
	 
//	  TestObject returnObject = new TestObject(); 
//	  returnObject = test.getPolygon(req_id);	// select
//	  System.out.println(" TestObject  !! ");	  
//	  System.out.println("testObj.testid : " + returnObject.testid);
//	  System.out.println("testObj.testStr :" + returnObject.testStr);
	  
		
	}
	

}
